/**
 * Este es el javascript de entrda de la aplicacion
 * Segun desde que pagina se incluya, se precargan
 * los js necesarios
 */


/**
 * Handler de la carga del html llamador
 */
window.onload = function () {
    switch ($('#initScript').attr("p")) {

        case "login":
            $LAB
                .script("libs/JQuery/jquery-ui/jquery-ui.min.jsb").wait()
                .script("scripts/Util/CybRegional.jsb")
                .script("scripts/Util/Util.jsb").wait()
                .script("scripts/Auth.jsb")
                .script("scripts/Login.jsb").wait(function () {
                    slite.Login.init();
                });
            break;


        case "index":
            $.getJSON("config.json", function (data) {

                // Precargamos primero todos los HTMLS (principales de la aplicacion)
                len = data.templates.main.length;
                var i, item;
                for (i = 0; i <= len - 1; i++) {
                    item = data.templates.main[i];
                    $(item.dest).load(item.src);
                }

                // Obtenemos configuraicon basica necesaria
                getInitialCfg(function (result) {
                    var arrScripts = getIncludesIndex(result.data);
                    $LAB.script(arrScripts).wait(function () {
                        slite.Main.proyectConfig = data;
                        slite.Main.init();
                    });
                });

            });
            break;

    }


    //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


    /**
     * Obtencion de configuracion elemental necesaria
     * en el index
     * 
     * @param {function} callback funcion callback que se ejecutara finalizada
     *                            la query
     */
    function getInitialCfg(callback) {
        $.ajax({
            url: "db/DBMain.js",
            data: {
                FUNC: "GET_INITIAL_CFG"
            },
            type: "POST",
            dataType: "JSON",
            success: function (data) {
                if (data == undefined || data == null) {
                    console.log("Ocurrió un error inesperado");
                    callback(false, "Error");
                    return;
                }
                callback(data);
            },
            error: function (arg1, arg2, arg3) {
                callback(false,data);
            }
        });
    }

    /**
     * Obtencion de includes necesarios para el index
     * 
     * @param   {object} oCfg Configuracion que afecta los includes 
     * @returns {Array}  Archivos a incluir por el LABS
     */
    function getIncludesIndex(oCfg) {
        var arrScripts = [];
        var flagIncGoogle = false;
        var googleKey = "gme-colvensa";

        if (Number(oCfg.loginClienteNoEncontrado) === 1) {
            // Sin configuracion de cliente ID: llamada a la api sin key
            arrScripts.push("http://maps.google.com/maps/api/js?v=3.6&libraries=places");
            flagIncGoogle = true;
        } else {
            // Hay clienteID, evaluamos configuracion
            if (Number(oCfg.google) === 1) {
                // Tiene permiso de google, vemos que llamada de api usar
                flagIncGoogle = true;
                if (Number(oCfg.google_ban) === 0) {
                    // No esta baneado, usamos api con key
                    arrScripts.push("https://maps.googleapis.com/maps/api/js?client=" + googleKey + "&v=3.22&libraries=places");
                } else {
                    // Esta baneado, se llama a api sin key
                    arrScripts.push("https://maps.googleapis.com/maps/api/js?v=3.22&libraries=places");
                }
            }
        }

        arrScripts.push("libs/leaflet/leaflet.jsb");
        arrScripts.push("libs/leaflet/plugins/Label.jsb");
        arrScripts.push("libs/leaflet/plugins/BaseMarkerMethods.jsb");
        arrScripts.push("libs/leaflet/plugins/Marker.Label.jsb");
        arrScripts.push("libs/leaflet/plugins/CircleMarker.Label.jsb");
        arrScripts.push("libs/leaflet/plugins/Path.Label.jsb");
        arrScripts.push("libs/leaflet/plugins/Map.Label.jsb");
        arrScripts.push("libs/leaflet/plugins/FeatureGroup.Label.jsb");
        if (flagIncGoogle) {
            // Si se llamo a la api de google arriba, se tiene que incluir este jsb tambien
            arrScripts.push("libs/leaflet/plugins/Google.jsb");
        }
        arrScripts.push("libs/leaflet/plugins/Bing.jsb");
        arrScripts.push("libs/leaflet/plugins/leaflet.measure.jsb");
        arrScripts.push("scripts/Util/CybRegional.jsb");
        arrScripts.push("scripts/Util/download.jsb");
        arrScripts.push("scripts/Util/HashCoords.jsb");
        arrScripts.push("scripts/Util/Util.jsb");
        arrScripts.push("scripts/Auth.jsb");
        arrScripts.push("scripts/Util/MapsProvider.jsb");
        arrScripts.push("libs/Google/jsapi.jsb");
        arrScripts.push("libs/JQuery/jquery-ui/jquery-ui.min.jsb");
        arrScripts.push("libs/JQuery/spin.min.jsb");
        arrScripts.push("libs/JQuery/jquery.inputmask.bundle.min.jsb");
        arrScripts.push("libs/JQuery/HoldOn.min.jsb");
        arrScripts.push("libs/Google/google_table.jsb");
        arrScripts.push("scripts/reports/Stack.jsb");
        arrScripts.push("libs/JQuery/jquery-ui-timepicker-addon.jsb");
        arrScripts.push("scripts/reports/QuickReport.jsb");
        arrScripts.push("scripts/reports/StandardReport.jsb");
        arrScripts.push("scripts/Toolbar.jsb");
        arrScripts.push("scripts/Layout.jsb");
        arrScripts.push("scripts/Grid.jsb");
        arrScripts.push("scripts/List.jsb");
        arrScripts.push("scripts/ListVehicles.jsb");
        arrScripts.push("scripts/Commands.jsb");
        arrScripts.push("scripts/Map.jsb");
        arrScripts.push("scripts/Main.jsb");
        return arrScripts;
    }




}
